/*
 * Copyright (C) 2021-2024  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef ACCEPTABLE_KEYSET_HH_B126511C06AA61CF296EDEAB8235B02C//date "+%s.%N"|md5sum|tr "[a-f]" "[A-F]"
#define ACCEPTABLE_KEYSET_HH_B126511C06AA61CF296EDEAB8235B02C

#include "src/domain.hh"
#include "src/keyset.hh"

#include <map>

namespace Fred {
namespace Akm {

struct DomainKeysetPair
{
    DomainFqdn domain_fqdn;
    Keyset keyset;
};

using AcceptableKeysets = std::map<DomainUuid, DomainKeysetPair>;
using AcceptableKeyset = AcceptableKeysets::value_type;

const DomainUuid& domain_uuid(const AcceptableKeyset&);
void append(AcceptableKeysets& collection, const AcceptableKeyset& item);
void merge(AcceptableKeysets& dst, const AcceptableKeysets& items);

} // namespace Fred::Akm
} // namespace Fred

#endif//ACCEPTABLE_KEYSET_HH_B126511C06AA61CF296EDEAB8235B02C
