/*
 * Copyright (C) 2021-2024  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef UPDATE_KEYSET_HH_EBFED19F116964511F767659C5F0DC0F//date "+%s.%N"|md5sum|tr "[a-f]" "[A-F]"
#define UPDATE_KEYSET_HH_EBFED19F116964511F767659C5F0DC0F

#include "src/database/impl/exception.hh"
#include "src/keyset.hh"
#include "src/keyset_metadata.hh"
#include "src/keyset_reference.hh"
#include "src/logger/log_entry.hh"

#include <libfred/opcontext.hh>
#include <libfred/registrable_object/domain/info_domain.hh>
#include <libfred/registrable_object/keyset/info_keyset.hh>

#include <boost/optional.hpp>

namespace Fred {
namespace Akm {
namespace Database {
namespace Impl {

struct UpdateKeysetFailed : OperationFailed
{
    using OperationFailed::OperationFailed;
};

KeysetReference update_keyset(
        const LibFred::OperationContext&,
        const LibFred::InfoDomainData& _info_domain_data,
        const LibFred::InfoKeysetData& _info_keyset_data,
        const KeysetMetadata&,
        const Keyset&,
        boost::optional<Logger::LogEntryNumericalId>);

} // namespace Fred::Akm::Database::Impl
} // namespace Fred::Akm::Database
} // namespace Fred::Akm
} // namespace Fred

#endif//UPDATE_KEYSET_HH_EBFED19F116964511F767659C5F0DC0F
