/*
 * Copyright (C) 2021  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */
#include "src/grpc_client/make_stub.hh"

#include <grpcpp/channel.h>
#include <grpcpp/create_channel.h>
#include <grpcpp/security/credentials.h>

namespace Fred {
namespace Akm {
namespace GrpcClient {

std::unique_ptr<CdnskeyProcessor::Api::Supervisor::Supervisor::Stub>
make_stub(const SupervisorConnectionString& _supervisor_connection_string)
{
    const auto channel = grpc::CreateChannel(*_supervisor_connection_string, grpc::InsecureChannelCredentials());
    return CdnskeyProcessor::Api::Supervisor::Supervisor::NewStub(channel);
}

} // namespace Fred::Akm::GrpcClient
} // namespace Fred::Akm
} // namespace Fred
