/*
 * Copyright (C) 2021  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */
#ifndef __LOG_ENTRY_FACTORY__7EAD6D3E2FBA0A521F63AA6E7F0A48D4
#define __LOG_ENTRY_FACTORY__7EAD6D3E2FBA0A521F63AA6E7F0A48D4

#include "src/domain.hh"
#include "src/logger/log_entry.hh"

#include <libgrill/connection.hh>

namespace Fred {
namespace Akm {
namespace Logger {

class LogEntryFactory
{
public:
    LogEntryFactory(LibGrill::Connection<LibGrill::Service::Logger>&);

    template<LogEntryType T>
    LogEntry<T> create_log_entry(const DomainId&, const DomainFqdn&);

private:
    LibGrill::Connection<LibGrill::Service::Logger>& connection_;
};

} // namespace Fred::Akm::Logger
} // namespace Fred::Akm
} // namespace Fred

#endif
