/*
 * Copyright (C) 2021  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef SCAN_TASK_HH_BA15CB0A72FC309FF48B209190768B26
#define SCAN_TASK_HH_BA15CB0A72FC309FF48B209190768B26

#include "src/domain.hh"

#include <map>
#include <set>

namespace Fred {
namespace Akm {

using Nameserver = LibStrong::Type<
        std::string,
        struct NameserverTag_,
        LibStrong::Collect<LibStrong::Skill::Comparable, LibStrong::Skill::Streamable>::SuperSkill>;

struct ScanTaskInfo
{
    DomainUuid uuid;
    ScanType scan_type;
    std::set<Nameserver> nameservers;
};

using ScanTasks = std::map<DomainFqdn, ScanTaskInfo>;

} // namespace Fred::Akm
} // namespace Fred

#endif//SCAN_TASK_HH_BA15CB0A72FC309FF48B209190768B26
